<template>
  <div class="px-3 py-4  justify-center ">
<div class="shadow flex">
    <input v-model="username" type="text" name="username" class="w-full rounded p-2" placeholder="Search for other user...">
    <button class="bg-white w-auto flex justify-end items-center text-blue-500 p-2 hover:text-blue-400" v-on:click="GetUser()">
        <i class="material-icons">search</i>
    </button>
</div>
         
    <div class="mt-4 ">
      
      <div class="mt-6">
        <div class="bg-white shadow rounded-md overflow-hidden my-6">
        
          <table class="text-left w-full border-collapse ">
            <thead class="border-b">
              <tr>
                <th
                  class="py-3 px-5 bg-indigo-800 font-medium uppercase text-sm text-gray-100"
                >
                  Username
                </th>
                <th
                  class="py-3 px-5 bg-indigo-800 font-medium uppercase text-sm text-gray-100"
                >
                  Role
                </th>

                <th
                  class="py-3 px-5 bg-indigo-800 font-medium uppercase text-sm text-gray-100"
                >
                  Follow
                </th>
               
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="(user, x) in this.users" :key="x"

                class="hover:bg-gray-200"
              >
                <td class="py-4 px-6 border-b text-gray-700 text-lg">
                  {{ user.username}}
                </td>
                <td class="py-4 px-6 border-b text-gray-500">
                  User
                </td>
                                <td class="py-4 px-6 border-b text-gray-500">
   <button v-if=!user.followed v-on:click="FollowUser(user, user.followed)" type="button" class="mr-3 text-sm bg-blue-700 hover:bg-blue-700 text-white py-1 px-2 rounded focus:outline-none focus:shadow-outline">Follow</button>
        <button v-if=user.followed v-on:click="FollowUser(user, user.followed)" type="button" class="mr-3 text-sm bg-blue-700 hover:bg-blue-700 text-white py-1 px-2 rounded focus:outline-none focus:shadow-outline">Unfollow</button>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
    </div>
  </div>

  </div>
</template>

<script>
import axios from 'axios'

export default {
name:"FriendsTable",
data(){
    return{
        users:[],
        username:"",
        user_service_url: import.meta.env.VITE_USER_URL 
    };
},
methods:{
    FollowUser(user, followed){

    var userId = user.id 
    var followAction = "follow" 
    
    var userAction = "unfollow"

    if (!followed){
      userAction = "follow" 
    }

    console.log('action = ' + userAction)
    axios
      .request({
        method: 'post',
        url:
          this.user_service_url + '/' + userAction + '/' + userId,
        headers: {
          'Content-Type': 'application/json',
          'Access-Control-Allow-Origin': '*',
          Accept: 'application/json',
          Authorization: `${localStorage.token}`,
        },
      })
      .then((response) => {
        console.log(response)
          if(userAction == followAction){
            user.followed = true
          }
          else{
            user.followed = false
          }
        })
      
      .catch(function (error) {      
        console.log(error);
      });
    },
//test
    GetUser(){
      console.log(import.meta.env.VITE_USER_URL)
    axios
      .request({
        method: 'get',
        url:
          this.user_service_url +  '/users/getUser/' + this.username,
        headers: {
          'Content-Type': 'application/json',
          'Access-Control-Allow-Origin': '*',
          Accept: 'application/json',
          Authorization: `${localStorage.token}`,
        },
      })
      .then((response) => {
        this.users.splice(0);
        if (response.data != null){
          this.users.push(response.data)
        }
        
      })
      .catch(function (error) {      
        console.log(error);
      });
    }


},
  mounted(){
console.log(import.meta.env.VITE_USER_URL)
    axios
      .request({
        method: 'get',
        url:
          this.user_service_url + "/users/getUsers",
        headers: {
          'Content-Type': 'application/json',
          'Access-Control-Allow-Origin': '*',
          Accept: 'application/json',
          Authorization: `${localStorage.token}`,
        },
      })
      .then((response) => {
        this.users = response.data;
        this.users.forEach(user => {
            console.log(user)
        });
        console.log('theses are the users: ', response.data);
      })
      .catch(function (error) {      
        console.log(error);
      });
  }



}
</script>

<style>

</style>